package ch.ethz.inf.vs.nethz.tutorial;

import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.ProgressBar;
import android.widget.TextView;

public class WorkerActivity extends AppCompatActivity {
    private ProgressBar progress;
    private TextView textview;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_worker);

        progress = (ProgressBar) findViewById(R.id.progress_bar);
        textview = (TextView) findViewById(R.id.txt_progress);

        new MyWorker().execute(20);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        return false;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    class MyWorker extends AsyncTask<Integer, Integer, Void> {

        private int index = 0;

        @Override
        protected void onPreExecute() {
            progress.setMax(100);
            progress.setProgress(0);
        }

        @Override
        protected Void doInBackground(Integer... step) {
            for (int i = 0; i < 100 / step[0]; ++i) {
                try {
                    Thread.sleep(500);
                    index += step[0];
                } catch (InterruptedException e) {
                }
                publishProgress(step); // run onProgressUpdate on UI thread
            }
            return null;
        }

        @Override
        protected void onProgressUpdate(final Integer... values) {
            textview.setText(Integer.toString(index));
            progress.incrementProgressBy(values[0]);
        }

        @Override
        protected void onPostExecute(final Void result) {
            textview.setText(R.string.done);
        }
    }
}
